using System;
using System.Collections.Generic;
using System.Text;

namespace D_CollectionsGenerics
{
    class CollectionsGenerics
    {
        class CustomerData{
            public String age;
            public String hometown;
            public CustomerData(string age, string hometown) {
                this.age = age;
                this.hometown = hometown;
            }
        }
        static string GetInput(string prompt) {
            Console.Write(prompt);
            return Console.ReadLine();
        }
        static void Main(string[] args)
        {
            Dictionary<string, CustomerData> customers = new Dictionary<string, CustomerData>();
            Boolean done = false;
            string name, hometown, age;
            while (!done) {
                string command = GetInput("Your next command>");
                switch (command) {
                    case "exit":
                        done = true;
                        break;
                    case "listcustomers":
                        Console.WriteLine("Total number of customers: " + customers.Count);
                        foreach (string n in customers.Keys) {
                            Console.WriteLine(n + " from " + customers[n].hometown + 
                                ", age " + customers[n].age);
                        }
                        break;
                    case "addcustomer":
                        name = GetInput("The name of the customer to add>");
                        if (customers.ContainsKey(name))
                        {
                            Console.WriteLine("Customer already exists");
                            break;
                        }
                        hometown = GetInput("Enter " + name + "\'s hometown>");
                        age = GetInput("Enter " + name + "\'s age>");
                        customers[name] = new CustomerData(age, hometown);
                        break;
                    case "deletecustomer":
                        name = GetInput("The name of the customer to delete>");
                        if (customers.Remove(name)) {
                            Console.WriteLine("Deletion succesful");
                        } else {
                            Console.WriteLine("Customer not found");
                        }
                        break;
                    default:
                        Console.WriteLine("Incorrect command");
                        break;
                }
            }
        }
    }
}
